searchData={"content_type":"text/markdown","items":[{"doc":"Handles the retrieval of token from Auth0 and their verification/validation.","ref":"PrimaAuth0Ex.html","title":"PrimaAuth0Ex","type":"module"},{"doc":"Force the refresh of the token for a given audience, invalidating both the local and the shared cache.","ref":"PrimaAuth0Ex.html#refresh_token_for/2","title":"PrimaAuth0Ex.refresh_token_for/2","type":"function"},{"doc":"Obtain a token for the given audience.","ref":"PrimaAuth0Ex.html#token_for/2","title":"PrimaAuth0Ex.token_for/2","type":"function"},{"doc":"Verify the integrity of a token, and validate its claims.\n\nIt is possible to set a list of permissions to validate.\nOnly tokens that include all the required permissions will pass validation.\n\nWhen `ignore_signature` is `true`, only checks the validity of claims of the token and not its signature.\nThis option should never be enabled in production-like environments, as it allows anyone to forge valid tokens.","ref":"PrimaAuth0Ex.html#verify_and_validate/4","title":"PrimaAuth0Ex.verify_and_validate/4","type":"function"},{"doc":"Plug that reads the permissions from the JWT passed in the `Authorization` header and stores them in the Absinthe context,\nso that they can be accessed by the `PrimaAuth0Ex.Absinthe.RequirePermissions` middleware.\n\nIt does not validate the token! You should use the `PrimaAuth0Ex.Plug.VerifyAndValidateToken` plug to do that.","ref":"PrimaAuth0Ex.Absinthe.CreateSecurityContext.html","title":"PrimaAuth0Ex.Absinthe.CreateSecurityContext","type":"module"},{"doc":"Absinthe middleware that ensures that the client has the required JWT permissions to access the GraphQL field.\nIf this is not the case, it returns an `unauthorized` error.\n\nThis middleware expects the required permissions of the field to be stored in the Absinthe context,\nwhich can be done by using the `PrimaAuth0Ex.Absinthe.CreateSecurityContext` plug.\n\nIf prima_auth0_ex is configured to run in \"dry run\" mode, this middleware simply logs a warning when the context doesn't include the given permissions.","ref":"PrimaAuth0Ex.Absinthe.RequirePermissions.html","title":"PrimaAuth0Ex.Absinthe.RequirePermissions","type":"module"},{"doc":"Credentials to access Auth0","ref":"PrimaAuth0Ex.Auth0Credentials.html","title":"PrimaAuth0Ex.Auth0Credentials","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.Auth0Credentials.html#from_env/1","title":"PrimaAuth0Ex.Auth0Credentials.from_env/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Auth0Credentials.html#t:t/0","title":"PrimaAuth0Ex.Auth0Credentials.t/0","type":"type"},{"doc":"Configuration wrapper","ref":"PrimaAuth0Ex.Config.html","title":"PrimaAuth0Ex.Config","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#authorization_service/1","title":"PrimaAuth0Ex.Config.authorization_service/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#clients/0","title":"PrimaAuth0Ex.Config.clients/0","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#clients/1","title":"PrimaAuth0Ex.Config.clients/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#clients/3","title":"PrimaAuth0Ex.Config.clients/3","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#clients!/2","title":"PrimaAuth0Ex.Config.clients!/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#default_client/0","title":"PrimaAuth0Ex.Config.default_client/0","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#default_client/2","title":"PrimaAuth0Ex.Config.default_client/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#default_client!/1","title":"PrimaAuth0Ex.Config.default_client!/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#jwks_kids_fetcher/1","title":"PrimaAuth0Ex.Config.jwks_kids_fetcher/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#redis/2","title":"PrimaAuth0Ex.Config.redis/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#redis!/1","title":"PrimaAuth0Ex.Config.redis!/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#refresh_strategy/1","title":"PrimaAuth0Ex.Config.refresh_strategy/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#server/2","title":"PrimaAuth0Ex.Config.server/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#server!/1","title":"PrimaAuth0Ex.Config.server!/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#telemetry_reporter/0","title":"PrimaAuth0Ex.Config.telemetry_reporter/0","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#token_cache/1","title":"PrimaAuth0Ex.Config.token_cache/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Config.html#token_service/1","title":"PrimaAuth0Ex.Config.token_service/1","type":"function"},{"doc":"Strategy used by `Joken` to obtain JWKS from Auth0.","ref":"PrimaAuth0Ex.JwksStrategy.html","title":"PrimaAuth0Ex.JwksStrategy","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"PrimaAuth0Ex.JwksStrategy.html#child_spec/1","title":"PrimaAuth0Ex.JwksStrategy.child_spec/1","type":"function"},{"doc":"Fetch signers with `JokenJwks.HttpFetcher`","ref":"PrimaAuth0Ex.JwksStrategy.html#fetch_signers/2","title":"PrimaAuth0Ex.JwksStrategy.fetch_signers/2","type":"function"},{"doc":"Callback for initializing options upon strategy startup","ref":"PrimaAuth0Ex.JwksStrategy.html#init_opts/1","title":"PrimaAuth0Ex.JwksStrategy.init_opts/1","type":"function"},{"doc":"Simple ETS counter based state machine","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html","title":"PrimaAuth0Ex.JwksStrategy.EtsCache","type":"module"},{"doc":"Returns 0 - no need to fetch signers or 1 - need to fetch","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#check_state/0","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.check_state/0","type":"function"},{"doc":"Loads fetched signers","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#get_signers/0","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.get_signers/0","type":"function"},{"doc":"Starts ETS cache","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#new/0","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.new/0","type":"function"},{"doc":"Puts fetched signers","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#put_signers/1","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.put_signers/1","type":"function"},{"doc":"Sets the cache status","ref":"PrimaAuth0Ex.JwksStrategy.EtsCache.html#set_status/1","title":"PrimaAuth0Ex.JwksStrategy.EtsCache.set_status/1","type":"function"},{"doc":"Utilities to help working with `prima_auth0_ex` on a local environment, without the need to integrate with Auth0.","ref":"PrimaAuth0Ex.LocalToken.html","title":"PrimaAuth0Ex.LocalToken","type":"module"},{"doc":"Forge a token with the desired payload.\nCustom claims can be passed as keyword options.\n\nThe signature will be generated locally, hence it will **not** be valid.\nFor this reason, this function should be used for local development only.","ref":"PrimaAuth0Ex.LocalToken.html#forge/2","title":"PrimaAuth0Ex.LocalToken.forge/2","type":"function"},{"doc":"Generate a UNIX timestamp shifted by the given time.\nCan be used to quickly generate timestamps for `iat` and `exp` claims.\n\n`options` must be compliant to `Timex.shift_options()`.\nE.g. `PrimaAuth0Ex.LocalToken.time_from_now(hours: -1)` will return the UNIX timestamp for one hour ago.","ref":"PrimaAuth0Ex.LocalToken.html#time_from_now/1","title":"PrimaAuth0Ex.LocalToken.time_from_now/1","type":"function"},{"doc":"Plug to verify and validate bearer tokens\n\nUsage:\n\n```\nplug PrimaAuth0Ex.Plug.VerifyAndValidateToken, required_permissions: [\"some:permission\"]\n```","ref":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.html","title":"PrimaAuth0Ex.Plug.VerifyAndValidateToken","type":"module"},{"doc":"The following options can be set to customize the behavior of this plug:\n\n* `required_permissions: [\"p1\", \"p2\"]` **(mandatory)**: sets the permissions that clients are required to have.\n  Clients who do not have **all** the required permissions are forbidden from accessing the API.\n  If you don't want to require any permissions, you can pass an empty list (`[]`) to this option.\n* `audience: \"my-audience\"`: sets the expected audience. Defaults to the audience set in `config.exs`.\n* `dry_run: false`: when true allows clients to access the API even when their token is missing/invalid.\n  Mostly useful for testing purposes. Default is `false`, overridable from `config.exs`.\n* `ignore_signature: false`: when true, validates claims found in a token without verifying its signature.\n  Should only be enabled in dev/test environments, as it allows anyone to forge valid tokens.\n  Default is `false`, overridable from `config.exs`.","ref":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.html#module-options","title":"Options - PrimaAuth0Ex.Plug.VerifyAndValidateToken","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.html#call/2","title":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.call/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.html#init/1","title":"PrimaAuth0Ex.Plug.VerifyAndValidateToken.init/1","type":"function"},{"doc":"A pre-defined module which sets up telemetry with a given reporter","ref":"PrimaAuth0Ex.Telemetry.html","title":"PrimaAuth0Ex.Telemetry","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.Telemetry.html#setup/0","title":"PrimaAuth0Ex.Telemetry.setup/0","type":"function"},{"doc":"A pre-defined telemetry handler","ref":"PrimaAuth0Ex.Telemetry.Handler.html","title":"PrimaAuth0Ex.Telemetry.Handler","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.Telemetry.Handler.html#handle_event/4","title":"PrimaAuth0Ex.Telemetry.Handler.handle_event/4","type":"function"},{"doc":"Module to verify the integrity and validate the claims of tokens.","ref":"PrimaAuth0Ex.Token.html","title":"PrimaAuth0Ex.Token","type":"module"},{"doc":"Combines `generate_claims/1` and `encode_and_sign/2`","ref":"PrimaAuth0Ex.Token.html#generate_and_sign/2","title":"PrimaAuth0Ex.Token.generate_and_sign/2","type":"function"},{"doc":"Same as `generate_and_sign/2` but raises if error","ref":"PrimaAuth0Ex.Token.html#generate_and_sign!/2","title":"PrimaAuth0Ex.Token.generate_and_sign!/2","type":"function"},{"doc":"Returns the list of permissions held by a token.\n\nIn case of missing permissions claim or malformed token it defaults to an empty list.\nNote that this function does not verify the signature of the token.","ref":"PrimaAuth0Ex.Token.html#peek_permissions/1","title":"PrimaAuth0Ex.Token.peek_permissions/1","type":"function"},{"doc":"Combines `verify/2` and `validate/2`","ref":"PrimaAuth0Ex.Token.html#verify_and_validate/3","title":"PrimaAuth0Ex.Token.verify_and_validate/3","type":"function"},{"doc":"Same as `verify_and_validate/2` but raises if error","ref":"PrimaAuth0Ex.Token.html#verify_and_validate!/3","title":"PrimaAuth0Ex.Token.verify_and_validate!/3","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.Token.html#verify_and_validate_token/4","title":"PrimaAuth0Ex.Token.verify_and_validate_token/4","type":"function"},{"doc":"GenServer that handles the storage and refresh of tokens.\n\nEvery time a token for a new audience is requested, it retrieves it either from a cache (when possible)\nor from an authorization provider.\nThen, it runs periodic checks to ensure that all tokens are still valid, and it refreshes them when necessary.","ref":"PrimaAuth0Ex.TokenProvider.html","title":"PrimaAuth0Ex.TokenProvider","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"PrimaAuth0Ex.TokenProvider.html#child_spec/1","title":"PrimaAuth0Ex.TokenProvider.child_spec/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.html#refresh_token_for/2","title":"PrimaAuth0Ex.TokenProvider.refresh_token_for/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.html#start_link/1","title":"PrimaAuth0Ex.TokenProvider.start_link/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.html#token_for/2","title":"PrimaAuth0Ex.TokenProvider.token_for/2","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.html#t:t/0","title":"PrimaAuth0Ex.TokenProvider.t/0","type":"type"},{"doc":"Implementation of `PrimaAuth0Ex.TokenProvider.AuthorizationService` for Auth0.","ref":"PrimaAuth0Ex.TokenProvider.Auth0AuthorizationService.html","title":"PrimaAuth0Ex.TokenProvider.Auth0AuthorizationService","type":"module"},{"doc":"Fetches key ids (aka `kid`s) from Auth0 JWKS","ref":"PrimaAuth0Ex.TokenProvider.Auth0JwksKidsFetcher.html","title":"PrimaAuth0Ex.TokenProvider.Auth0JwksKidsFetcher","type":"module"},{"doc":"Behaviour to handle communications with an authorization service.","ref":"PrimaAuth0Ex.TokenProvider.AuthorizationService.html","title":"PrimaAuth0Ex.TokenProvider.AuthorizationService","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.AuthorizationService.html#c:retrieve_token/2","title":"PrimaAuth0Ex.TokenProvider.AuthorizationService.retrieve_token/2","type":"callback"},{"doc":"Implementation of `PrimaAuth0Ex.TokenProvider.TokenService` that caches tokens on\nan external cache in order to limit the requests made to Auth0 by reusing tokens.\n\nThe external cache can be shared among different instances of the same service: in that\ncase, when one of the instances refreshes the token and updates the shared cache, the other\ninstances will retrieve the new token from the new cache and will not have to generate a new\none from the authorization provider.","ref":"PrimaAuth0Ex.TokenProvider.CachedTokenService.html","title":"PrimaAuth0Ex.TokenProvider.CachedTokenService","type":"module"},{"doc":"Implementation of `PrimaAuth0Ex.TokenProvider.TokenCache` that persists encrypted copies of tokens on Redis.\n\nEncryption-related functionalities are implemented in `PrimaAuth0Ex.TokenProvider.TokenEncryptor`.","ref":"PrimaAuth0Ex.TokenProvider.EncryptedRedisTokenCache.html","title":"PrimaAuth0Ex.TokenProvider.EncryptedRedisTokenCache","type":"module"},{"doc":"Behaviour to fetch key ids (aka `kid`s) from a JWKS server","ref":"PrimaAuth0Ex.TokenProvider.JwksKidsFetcher.html","title":"PrimaAuth0Ex.TokenProvider.JwksKidsFetcher","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.JwksKidsFetcher.html#c:fetch_kids/1","title":"PrimaAuth0Ex.TokenProvider.JwksKidsFetcher.fetch_kids/1","type":"callback"},{"doc":"Implementation of `PrimaAuth0Ex.TokenProvider.RefreshStrategy` that relies on a probabilistic approach\nto decide whether to refresh a token.\n\nThe reason why a probabilistic approach is desirable is that multiple instances may share a common cache of tokens.\nIf all of them used the same deterministic approach to decide when to refresh tokens,\nthe likelihood of concurrent regeneration of the cached token would be higher.\n\nThis strategy defines a \"refresh window\", which is a time span in the lifespan of a token when\nthe refresh may happen (e.g., \"from 50% to 75% of the life of the token\").\nThe refresh time will be a random time in the refresh window.\n\nThe \"refresh window\" can be customized from config as follows\n\n  config :prima_auth0_ex, :clients, default_client: [\n    min_token_duration: 0.5,\n    max_token_duration: 0.75\n  ]","ref":"PrimaAuth0Ex.TokenProvider.ProbabilisticRefreshStrategy.html","title":"PrimaAuth0Ex.TokenProvider.ProbabilisticRefreshStrategy","type":"module"},{"doc":"Behaviour to define a strategy to decide whether to refresh a token or keep using it for some more time.","ref":"PrimaAuth0Ex.TokenProvider.RefreshStrategy.html","title":"PrimaAuth0Ex.TokenProvider.RefreshStrategy","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.RefreshStrategy.html#c:refresh_time_for/2","title":"PrimaAuth0Ex.TokenProvider.RefreshStrategy.refresh_time_for/2","type":"callback"},{"doc":"Behaviour that defines a cache for tokens.","ref":"PrimaAuth0Ex.TokenProvider.TokenCache.html","title":"PrimaAuth0Ex.TokenProvider.TokenCache","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenCache.html#c:get_token_for/2","title":"PrimaAuth0Ex.TokenProvider.TokenCache.get_token_for/2","type":"callback"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenCache.html#c:set_token_for/3","title":"PrimaAuth0Ex.TokenProvider.TokenCache.set_token_for/3","type":"callback"},{"doc":"Module to perform authenticated symmetric encryption of binaries.\n\nThe key used for encryption is set from config:\n\n  config :prima_auth0_ex, :redis,\n    encryption_key: \"uhOrqKvUi9gHnmwr60P2E1hiCSD2dtXK1i6dqkU4RTA=\"","ref":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.html","title":"PrimaAuth0Ex.TokenProvider.TokenEncryptor","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.html#decrypt/1","title":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.decrypt/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.html#encrypt/1","title":"PrimaAuth0Ex.TokenProvider.TokenEncryptor.encrypt/1","type":"function"},{"doc":"Information related to a JWT, including the JWT itself and additional metadata","ref":"PrimaAuth0Ex.TokenProvider.TokenInfo.html","title":"PrimaAuth0Ex.TokenProvider.TokenInfo","type":"module"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenInfo.html#from_jwt/1","title":"PrimaAuth0Ex.TokenProvider.TokenInfo.from_jwt/1","type":"function"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenInfo.html#t:t/0","title":"PrimaAuth0Ex.TokenProvider.TokenInfo.t/0","type":"type"},{"doc":"Behaviour to deal with retrieval and refresh of tokens","ref":"PrimaAuth0Ex.TokenProvider.TokenService.html","title":"PrimaAuth0Ex.TokenProvider.TokenService","type":"behaviour"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenService.html#c:refresh_token/4","title":"PrimaAuth0Ex.TokenProvider.TokenService.refresh_token/4","type":"callback"},{"doc":"","ref":"PrimaAuth0Ex.TokenProvider.TokenService.html#c:retrieve_token/2","title":"PrimaAuth0Ex.TokenProvider.TokenService.retrieve_token/2","type":"callback"},{"doc":"# The MIT License (MIT)\n\nCopyright (c) 2020 Prima.it\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"# prima_auth0_ex\n\n[![Module Version](https://img.shields.io/hexpm/v/prima_auth0_ex.svg)](https://hex.pm/packages/prima_auth0_ex)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/prima_auth0_ex/)\n[![Total Download](https://img.shields.io/hexpm/dt/prima_auth0_ex.svg)](https://hex.pm/packages/prima_auth0_ex)\n[![License](https://img.shields.io/hexpm/l/prima_auth0_ex.svg)](https://github.com/primait/auth0_ex/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/primait/auth0_ex.svg)](https://github.com/primait/auth0_ex/commits/master)\n\nAn easy-to-use library to authenticate machine-to-machine communications through Auth0.\n\nSupports both retrieval of JWTs and their verification and validation.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"- [Installation](#installation)\n- [Configuration](#configuration)\n  - [Operational requirements](#operational-requirements)\n- [Usage](#usage)\n- [Development](#development)","ref":"readme.html#table-of-contents","title":"Table of contents - Overview","type":"extras"},{"doc":"The package can be installed by adding `prima_auth0_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:prima_auth0_ex, \"~> 0.6.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Overview","type":"extras"},{"doc":"`prima_auth0_ex` can be configured to be used for an API consumer, an API provider or both.\n\n#","ref":"readme.html#configuration","title":"Configuration - Overview","type":"extras"},{"doc":"To configure the library for use from a client (i.e. a service that needs to obtain tokens to access some API),\nthe following configuration is supported:\n\n```elixir\nconfig :prima_auth0_ex, :clients, default_client: [\n  # Base url for Auth0 API\n  auth0_base_url: \"https://tenant.eu.auth0.com\"\n  # Credentials on Auth0\n  client_id: \"\",\n  client_secret: \"\",\n  # Namespace for tokens of this client on the shared cache. Should be unique per client\n  cache_namespace: \"my-client\"\n]\n```\n\n**If the client will access APIs that perform validation of permissions, make sure that the API on Auth0 is configured to have both \"Enable RBAC\" and \"Add Permissions in the Access Token\" enabled.**\nOtherwise, the JWTs generated by Auth0 may not include the necessary permissions claims.\n\nA visualization of the logic behind the `TokenProvider` is available [here](client_flow.jpg).\n\n##","ref":"readme.html#api-consumer","title":"API Consumer - Overview","type":"extras"},{"doc":"If you need to use multiple clients which target different Auth0 instances, you can configure them like so\n\n```elixir\nconfig :prima_auth0_ex, :clients, your_client_name: [\n  # Base url for Auth0 API\n  auth0_base_url: \"https://tenant.eu.auth0.com\"\n  # Credentials on Auth0\n  client_id: \"\",\n  client_secret: \"\",\n  # Namespace for tokens of this client on the shared cache. Should be unique per client\n  cache_namespace: \"my-client\"\n]\n```\n\nYou can configure multiple `:clients`, the name is arbitrary and the only requirement is that it be unique.\n\n#","ref":"readme.html#multiple-clients","title":"Multiple clients - Overview","type":"extras"},{"doc":"To configure the library for use from a server (ie. a service that exposes an API),\nthe following configuration is supported:\n\n```elixir\nconfig :prima_auth0_ex, :server,\n  # Base url for Auth0 API\n  auth0_base_url: \"https://your-tenant.eu.auth0.com/\",\n  # Default audience used to verify tokens. Not necessary when audience is set explicitly on usage.\n  audience: \"audience\",\n  # Issuer used to verify tokens. Can be found at https://your-tenant.eu.auth0.com/.well-known/openid-configuration\n  issuer: \"https://tenant.eu.auth0.com/\",\n  # Whether to perform the first retrieval of JWKS synchronously. Defaults to true.\n  first_jwks_fetch_sync: true,\n  # When true, logs errors in validation of tokens, but it does not stop the request when the token is not valid.\n  # Defaults to false.\n  dry_run: false,\n  # When true, only the claims of tokens are validated, but their signature is not verified.\n  # This is useful for local development but should NEVER be enabled on production-like systems.\n  # Defaults to false.\n  ignore_signature: false,\n  # Level used to log requests where the authorization header is missing. \n  missing_auth_header_log_level: :warn\n```\n\n#","ref":"readme.html#api-provider","title":"API Provider - Overview","type":"extras"},{"doc":"Clients can be configured to use caching through Redis. To use cachine you can use the following configuration:\n\n```elixir\nconfig :prima_auth0_ex, :redis,\n  # Enables cache on redis for tokens obtained from Auth0. Defaults to false.\n  enabled: true,\n  # AES 256 key used to encrypt tokens on the shared cache.\n  # Can be generated via `:crypto.strong_rand_bytes(32) |> Base.encode64()`.\n  encryption_key: \"uhOrqKvUi9gHnmwr60P2E1hiCSD2dtXK1i6dqkU4RTA=\",\n  connection_uri: \"redis://redis:6379\",\n  # Read here for more infos: https://hexdocs.pm/redix/Redix.html#module-ssl\n  ssl_enabled: false,\n  ssl_allow_wildcard_certificates: false\n```\n\nNote that right now caching is assumed to be all-or-nothing with respect to multiple clients i.e. either all clients use caching or none of them do. If you have a use case that is not supported by this please contact us so that we can see what we can do.\n\n#","ref":"readme.html#redis-caching","title":"Redis & caching - Overview","type":"extras"},{"doc":"To cache tokens on Redis you'll need to generate a `cache_encryption_key`. This can be done either by running `mix keygen` or by using the following snippet:\n\n```elixir\n:crypto.strong_rand_bytes(32) |> Base.encode64()\n```\n\nAlternatively you can generate it on command line (Linux/MacOSX) with:\n\n```\ndd if=/dev/random bs=1 count=32 | base64\n```\n\n> :warning: **The token needs to be 32 bytes long AND base64 encoded**, failing to do so will result in tokens not getting cached on Redis. :warning:","ref":"readme.html#operational-requirements","title":"Operational requirements - Overview","type":"extras"},{"doc":"#","ref":"readme.html#usage","title":"Usage - Overview","type":"extras"},{"doc":"Tokens for a given audience can be obtained as follows:\n\n```elixir\n{:ok, token} = PrimaAuth0Ex.token_for(\"target-audience\")\n```\n\nThis call will target the `:default_client`, assuming it's configured.\n\nInstead, if you want to obtain a token for a specific client you can do it like so:\n\n```elixir\n{:ok, token} = PrimaAuth0Ex.token_for(\"target-audience\", :target_client)\n```\n\nTokens are automatically refreshed when they expire and when the signing keys are revoked.\nIt is also possible to force the refresh of the token, both on the local instance and on the shared cache, as follows:\n\n```elixir\n# With the default client\n{:ok, new_token} = PrimaAuth0Ex.refresh_token_for(\"target-audience\")\n\n# With a specific client\n{:ok, new_token} = PrimaAuth0Ex.refresh_token_for(\"target-audience\", :target_client)\n```\n\nA use-case for forcing the refresh of the token may be e.g. if new permissions are added to an application on Auth0, and we want to propagate this change without waiting for the natural expiration of tokens.\n\n#","ref":"readme.html#obtaining-tokens","title":"Obtaining tokens - Overview","type":"extras"},{"doc":"Tokens can be verified and validated as follows:\n\n```elixir\n{:ok, claims} = PrimaAuth0Ex.verify_and_validate(\"my-token\")\n```\n\nThe audience and the required permissions can be explicitly specified:\n\n```elixir\n{:ok, claims} = PrimaAuth0Ex.verify_and_validate(\"my-token\", \"my-audience\", [\"required-permission1\"])\n```\n\nFor `Plug`-based applications, a plug to automate this process is available:\n\n```elixir\nplug PrimaAuth0Ex.Plug.VerifyAndValidateToken\n```\n\nThis will return `401 Forbidden` to requests without a valid bearer token.\n\nThe plug supports the following options:\n\n- `audience: \"my-audience\"` to explicitly set the expected audience. When not defined it defaults to the audience configured in `:prima_auth0_ex, :server, :audience`;\n- `required_permissions: [\"p1\", \"p2\"]` to forbid access to users who do not have all the required permissions;\n- `dry_run` to allow access to the API when the token is not valid (mostly useful for testing purposes).\n\n##","ref":"readme.html#verifying-tokens","title":"Verifying tokens - Overview","type":"extras"},{"doc":"To validate permissions in your Graphql API on a per-query/per-mutation basis, an option is to define an Absinthe middleware. To this end, you can use the [PrimaAuth0Ex.Absinthe.RequirePermissions](lib/prima_auth0_ex/absinthe/require_permissions.ex) included with the library or build your own.\n\nThis middleware has a companion plug: [PrimaAuth0Ex.Absinthe.CreateSecurityContext](lib/prima_auth0_ex/absinthe/create_security_context.ex), which can be used to pass the user's permissions to the Absinthe context.\n\nIt is important to note that the middleware will only validate permissions: other validations and the verification of the signature will still need to be done elsewhere (e.g. using the aforementioned plug).\n\nThe middleware can be used in your schema as follows:\n\n```elixir\nfield ... do\n  middleware RequirePermissions, [\"your-required-permission\"]\n  resolve &Resolver.resolve_function/3\n```\n\n#","ref":"readme.html#validating-permissions-with-absinthe","title":"Validating permissions with Absinthe - Overview","type":"extras"},{"doc":"`prima_auth0_ex` uses `:telemetry` to [emit two events](/lib/prima_auth0_ex/token_provider/auth0_authorization_service.ex#L56)\n\n- `[:prima_auth0_ex, :retrieve_token, :success]`\n- `[:prima_auth0_ex, :retrieve_token, :failure]`\n\nwhich represent a successful or failed attempt to fetch a new JWT from Auth0.\n\nIf you want to leverage them you can\n\n- register a custom handler (see [here](https://hexdocs.pm/telemetry/readme.html)) or\n- configure the [pre-defined handler](/lib/prima_auth0_ex/telemetry.ex)\n\nThe pre-defined handler tries to be as agnostic as possible from the underlying reporter and it can be configured by setting the following\n\n```elixir\nconfig :prima_auth0_ex, telemetry_reporter: TelemetryReporter\n```\n\nAt startup, the library will check if a reporter has been configured and then it will attach it as a handler.\n\nTo work, the reporter needs to have an `increment` method like in Statix or Instruments, and it will then increment one of two counters: `auth0.token`. Each counter will be tagged by `audience` and `status` (`success` or `failure`).","ref":"readme.html#metrics","title":"Metrics - Overview","type":"extras"},{"doc":"The test suite can be executed as follows:\n\n```bash\nmix test\n```\n\nBy default tests that integrate with Auth0 are excluded.\nTo run them, configure your auth0 credentials and audience in `config/test.exs` and run:\n\n```bash\nmix test --include external\n```\n\nAlways run formatter, linter and dialyzer before pushing changes:\n\n```bash\nmix check\n```","ref":"readme.html#development","title":"Development - Overview","type":"extras"}]}